#!/opt/cyops-auth/.env/bin/python3
""" Copyright start
Copyright (C) 2008 - 2020 Fortinet Inc.
All rights reserved.
FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
Copyright end """

import sys, subprocess, argparse

def execute_cmd(cmd):
    pipes = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
    std_out, std_err = pipes.communicate()
    if pipes.returncode != 0:
        # an error happened!
        sys.stderr.write(std_err.strip().decode("utf-8"))
        return pipes.returncode
    sys.stdout.write(std_out.strip().decode("utf-8"))
    return 0

def define_parser(parser):
    parser.add_argument('--command', help="Command name", dest='cmd', type=str, required=True)
    parser.add_argument('--input-args', help="Input arguments for command", dest='input', type=str, required=False)

def execute_pg_db_size_cmd():
    cmd = "psql -U postgres postgres -t -c \"SHOW data_directory;\" | xargs -i du -sh {} | awk '{print $1}'"
    return execute_cmd(cmd)

def execute_update_es_credentials(es_user_pass):

    conf_util = "/opt/cyops/configs/scripts/confUtil.py"
    db_config = "/opt/cyops/configs/database/db_config.yml"
    executable = "python3 " + conf_util + " -f " + db_config + " "
    cmd = executable + " -k es_user -v elastic"
    execute_cmd(cmd)
    cmd = executable + " -k secret -v " + es_user_pass
    execute_cmd(cmd)
    cmd = executable + " -k use_ssl -v true"
    execute_cmd(cmd)
    cmd = "systemctl restart cyops-search"
    return execute_cmd(cmd)
    
if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    define_parser(parser)
    args = parser.parse_args()

    if args.cmd == 'get-postgresql-db-size':
        exit(execute_pg_db_size_cmd())
    elif args.cmd == 'update-es-credentials':
        exit(execute_update_es_credentials(args.input))
    
    sys.stderr.write("Command [" + args.cmd + "] is not valid")
    exit(1)
